searchData={"items":[{"type":"module","title":"RDF.XML","doc":"An implementation of the RDF 1.1 XML Syntax.\n\nIt is implemented as a `RDF.Serialization.Format`, so it can be used like any other\nserialization format of RDF.ex.\n\n    graph = RDF.XML.read_file!(\"file.rdf\")\n    RDF.XML.write_file!(graph, \"file.rdf\")\n\nFor a description of the capabilities and options (which can be passed also to\nthe `read` and `write` functions) see `RDF.XML.Decoder` and `RDF.XML.Encoder`.\n\nFor more on the RDF-XML format see  .","ref":"RDF.XML.html"},{"type":"function","title":"RDF.XML.read_file/2","doc":"Deserializes a graph or dataset from a file.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.","ref":"RDF.XML.html#read_file/2"},{"type":"function","title":"Options - RDF.XML.read_file/2","doc":"General serialization-independent options:\n\n- `:stream`: Allows to enable reading the data from a file directly via a\nstream (default: `false` on this function, `true` on the bang version)\n- `:gzip`: Allows to read directly from a gzipped file (default: `false`)\n- `:file_mode`: A list with the Elixir `File.open` modes to be used for reading\n  (default: `[:read, :utf8]`)\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_file/2-options"},{"type":"function","title":"RDF.XML.read_file!/2","doc":"Deserializes a graph or dataset from a file.\n\nAs opposed to `read_file/2`, it raises an exception if an error occurs and\ndefaults to `stream: true`.\n\nSee `read_file/3` for the available format-independent options.\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_file!/2"},{"type":"function","title":"RDF.XML.read_stream/2","doc":"Deserializes a graph or dataset from a stream.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_stream/2"},{"type":"function","title":"RDF.XML.read_stream!/2","doc":"Deserializes a graph or dataset from a stream.\n\nAs opposed to `read_stream/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_stream!/2"},{"type":"function","title":"RDF.XML.read_string/2","doc":"Deserializes a graph or dataset from a string.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_string/2"},{"type":"function","title":"RDF.XML.read_string!/2","doc":"Deserializes a graph or dataset from a string.\n\nAs opposed to `read_string/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.RDF.XML.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"RDF.XML.html#read_string!/2"},{"type":"function","title":"RDF.XML.write_file/3","doc":"Serializes an RDF data structure to a file.\n\nIt returns `:ok` if successful or `{:error, reason}` if an error occurs.","ref":"RDF.XML.html#write_file/3"},{"type":"function","title":"Options - RDF.XML.write_file/3","doc":"General serialization-independent options:\n\n- `:stream`: Allows to enable writing the serialized data to the file directly\n  via a stream. Possible values: `:string` or `:iodata` for writing to the file\n  with a stream of strings respective IO lists, `true` if you want to use streams,\n  but don't care for the exact method or `false` for not writing with\n  a stream (default: `false` on this function, `:iodata` on the bang version)\n- `:gzip`: Allows to write directly to a gzipped file (default: `false`)\n- `:force`: If not set to `true`, an error is raised when the given file\n  already exists (default: `false`)\n- `:file_mode`: A list with the Elixir `File.open` modes to be used for writing\n  (default: `[:write, :exclusive]`)\n\nSee the [module documentation of the encoder](`Elixir.RDF.XML.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"RDF.XML.html#write_file/3-options"},{"type":"function","title":"RDF.XML.write_file!/3","doc":"Serializes an RDF data structure to a file.\n\nAs opposed to `write_file/3`, it raises an exception if an error occurs.\n\nSee `write_file/3` for the available format-independent options.\n\nSee the [module documentation of the encoder](`Elixir.RDF.XML.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"RDF.XML.html#write_file!/3"},{"type":"function","title":"RDF.XML.write_stream/2","doc":"Serializes an RDF data structure to a stream.\n\nSee the [module documentation of the encoder](`Elixir.RDF.XML.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"RDF.XML.html#write_stream/2"},{"type":"function","title":"RDF.XML.write_string/2","doc":"Serializes an RDF data structure to a string.\n\nIt returns an `{:ok, string}` tuple, with `string` being the serialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the encoder](`Elixir.RDF.XML.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"RDF.XML.html#write_string/2"},{"type":"function","title":"RDF.XML.write_string!/2","doc":"Serializes an RDF data structure to a string.\n\nAs opposed to `write_string/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the encoder](`Elixir.RDF.XML.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"RDF.XML.html#write_string!/2"},{"type":"module","title":"RDF.XML.Decoder","doc":"A decoder for RDF/XML serializations to `RDF.Graph`s.\n\nAs for all decoders of `RDF.Serialization.Format`s, you normally won't use these\nfunctions directly, but via one of the `read_` functions on the `RDF.XML` format\nmodule or the generic `RDF.Serialization` module.","ref":"RDF.XML.Decoder.html"},{"type":"module","title":"Options - RDF.XML.Decoder","doc":"- `:base`: allows to specify the base URI to be used in contexts where relative\n  URIs are used and no base URI is defined with a `xml:base` definition\n- `:bnode_prefix`: allows to specify the prefix which auto-generated blank nodes\n  should get (default: `\"b\"`)","ref":"RDF.XML.Decoder.html#module-options"},{"type":"function","title":"RDF.XML.Decoder.decode/2","doc":"Decodes an RDF/XML string to a `RDF.Graph`.\n\nThe result is returned in an `:ok` tuple or an `:error` tuple in case of an error.\n\nFor a description of the available options see the [module documentation](`RDF.XML.Encoder`).","ref":"RDF.XML.Decoder.html#decode/2"},{"type":"function","title":"RDF.XML.Decoder.decode_from_stream/2","doc":"Decodes an RDF/XML stream to a `RDF.Graph`.\n\nFor a description of the available options see the [module documentation](`RDF.XML.Encoder`).","ref":"RDF.XML.Decoder.html#decode_from_stream/2"},{"type":"module","title":"RDF.XML.Encoder","doc":"An encoder for RDF/XML serializations of RDF.ex data structures.\n\nAs for all encoders of `RDF.Serialization.Format`s, you normally won't use these\nfunctions directly, but via one of the `write_` functions on the `RDF.XML` format\nmodule or the generic `RDF.Serialization` module.","ref":"RDF.XML.Encoder.html"},{"type":"module","title":"Options - RDF.XML.Encoder","doc":"- `:base`: : Allows to specify the base URI to be used for a `xml:base` declaration.\n  If not specified the one from the given graph is used or if there is also none\n  specified for the graph the `RDF.default_base_iri/0`.\n- `:prefixes`: Allows to specify the prefixes to be used as a `RDF.PrefixMap` or\n  anything from which a `RDF.PrefixMap` can be created with `RDF.PrefixMap.new/1`.\n  If not specified the ones from the given graph are used or if these are also not\n  present the `RDF.default_prefixes/0`.\n- `:implicit_base`: Allows to specify that the used base URI should not be encoded\n  in the generated serialization (default: `false`).\n- `:use_rdf_id`: Allows to determine if `rdf:ID` should be used when possible.\n   You can either provide a boolean value or a function which should return a boolean\n   value for a given `RDF.Description`. (default: `false`)\n- `:xml_declaration`: Allows to specify the XML declaration. Possible values:\n  - `true` (default): produces the default `<?xml version=\"1.0\" encoding=\"utf-8\"?>` declaration\n  - `false`: omits the XML declaration\n  - any value supported for `prolog` argument of `Saxy.encode!/2`\n    (only available on `encode/2`, not on `stream/2`)\n- `:producer`: This option allows you to provide a producer function, which will get\n  the input data (usually a `RDF.Graph`) and should produce a stream of the descriptions\n  to be encoded. This allows you to control the order of the descriptions, apply filters\n  etc.\n\n        iex> RDF.Graph.new([\n        ...>   EX.S1 |> EX.p1(EX.O1),\n        ...>   EX.S2 |> EX.p2(EX.O2),\n        ...> ])\n        ...> |> RDF.XML.write_string!(\n        ...>     prefixes: [ex: EX],\n        ...>     producer: fn graph ->\n        ...>       {first, rest} = RDF.Graph.pop(graph, EX.S2)\n        ...>       Stream.concat([first], RDF.Graph.descriptions(rest))\n        ...>     end)\n        ~S(<?xml version=\"1.0\" encoding=\"utf-8\"?>        )","ref":"RDF.XML.Encoder.html#module-options"},{"type":"function","title":"RDF.XML.Encoder.encode/2","doc":"Encodes the given RDF `data` structure to an RDF/XML string.\n\nThe result is returned in an `:ok` tuple or an `:error` tuple in case of an error.\n\nFor a description of the available options see the [module documentation](`RDF.XML.Encoder`).","ref":"RDF.XML.Encoder.html#encode/2"},{"type":"function","title":"RDF.XML.Encoder.stream/2","doc":"Encodes the given RDF `data` structure to an RDF/XML stream.\n\nBy default, the RDF/XML stream will emit single line strings for each of the\ndescriptions in the given `data`. But you can also receive the serialized RDF/XML\ndescription as IO lists aka iodata by setting the `:mode` option to `:iodata`.\n\nFor a description of the other available options see the [module documentation](`RDF.XML.Encoder`).","ref":"RDF.XML.Encoder.html#stream/2"},{"type":"exception","title":"RDF.XML.EncodeError","doc":"","ref":"RDF.XML.EncodeError.html"},{"type":"exception","title":"RDF.XML.ParseError","doc":"","ref":"RDF.XML.ParseError.html"},{"type":"extras","title":"README","doc":"# RDF-XML.ex\n\n[![Hex.pm](https://img.shields.io/hexpm/v/rdf_xml.svg?style=flat-square)](https://hex.pm/packages/rdf_xml)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/rdf_xml/)\n[![License](https://img.shields.io/hexpm/l/rdf_xml.svg)](https://github.com/rdf-elixir/rdf-xml-ex/blob/master/LICENSE.md)\n\n[![ExUnit Tests](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-build-and-test.yml/badge.svg)](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-build-and-test.yml)\n[![Dialyzer](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-dialyzer.yml/badge.svg)](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-dialyzer.yml)\n[![Quality Checks](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-quality-checks.yml/badge.svg)](https://github.com/rdf-elixir/rdf-xml-ex/actions/workflows/elixir-quality-checks.yml)\n\n\nAn implementation of the [W3C RDF 1.1 XML](http://www.w3.org/TR/rdf-syntax-grammar/) serialization format for Elixir and [RDF.ex].\n\nThe API documentation can be found [here](https://hexdocs.pm/rdf_xml/). For a guide and more information about RDF.ex and it's related projects, go to  .","ref":"readme.html"},{"type":"extras","title":"Features - README","doc":"- fully conforming RDF/XML implementation passing all the official tests (apart from the currently unsupported features below)\n- reader/writer for [RDF.ex] with support for reading and writing to streams","ref":"readme.html#features"},{"type":"extras","title":"Limitations - README","doc":"- XML canonicalization of `rdf:XMLLiteral`s  (`rdf:parseType=\"Literal\"`) is not supported\n- xmlns for `rdf` to shorten the syntax terms is not supported","ref":"readme.html#limitations"},{"type":"extras","title":"Installation - README","doc":"The [RDF-XML.ex](https://hex.pm/packages/rdf_xml) Hex package can be installed as usual, by adding `rdf_xml` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:rdf_xml, \"~> 1.1\"}]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - README","doc":"RDF-XML.ex can be used to serialize or deserialize RDF data structures by using the RDF.ex reader and writer functions as usual.\n\n```elixir\ngraph = RDF.XML.read_file!(\"file.rdf\")\nRDF.XML.write_file!(graph, \"file.rdf\")\n```\n\nAbove the common options of all RDF.ex encoders and decoders, the encoder and decoder of RDF-XML.ex supports some additional options. See the [API documentation](https://hexdocs.pm/rdf_xml/) for information about the available options.","ref":"readme.html#usage"},{"type":"extras","title":"Contributing - README","doc":"see [CONTRIBUTING](CONTRIBUTING.md) for details.","ref":"readme.html#contributing"},{"type":"extras","title":"Acknowledgements - README","doc":"The development of this project was sponsored by [NetzeBW](https://www.netze-bw.de/) for [NETZlive](https://www.netze-bw.de/unsernetz/netzinnovationen/digitalisierung/netzlive).","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Consulting - README","doc":"If you need help with your Elixir and Linked Data projects, just contact [NinjaConcept](https://www.ninjaconcept.com/) via  .","ref":"readme.html#consulting"},{"type":"extras","title":"License and Copyright - README","doc":"(c) 2020-present Marcel Otto. MIT Licensed, see [LICENSE](LICENSE.md) for details.\n\n\n\n[RDF.ex]:             https://hex.pm/packages/rdf","ref":"readme.html#license-and-copyright"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nThis project adheres to [Semantic Versioning](http://semver.org/) and\n[Keep a CHANGELOG](http://keepachangelog.com).","ref":"changelog.html"},{"type":"extras","title":"v1.2.0 - 2024-08-07 - Change Log","doc":"This version upgrades to RDF.ex v2.0.\n\nElixir versions < 1.13 and OTP version < 23 are no longer supported.\n\n\n[Compare v1.1.1...v1.2.0](https://github.com/rdf-elixir/rdf-xml-ex/compare/v1.1.1...v1.2.0)","ref":"changelog.html#v1-2-0-2024-08-07"},{"type":"extras","title":"v1.1.1 - 2024-03-18 - Change Log","doc":"","ref":"changelog.html#v1-1-1-2024-03-18"},{"type":"extras","title":"Added - Change Log","doc":"- optimizations of relative URI resolution against the base URI \n  (in non-`rdf:ID` cases)  \n\n\n[Compare v1.1.0...v1.1.1](https://github.com/rdf-elixir/rdf-xml-ex/compare/v1.1.0...v1.1.1)","ref":"changelog.html#added"},{"type":"extras","title":"v1.1.0 - 2024-01-16 - Change Log","doc":"Elixir versions < 1.12 are no longer supported","ref":"changelog.html#v1-1-0-2024-01-16"},{"type":"extras","title":"Added - Change Log","doc":"- option `:xml_declaration` on `RDF.XML.encode/2` and `RDF.XML.stream/2` to\n  customize or omit the generation of the XML declaration","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Change Log","doc":"- inconsistent encodings with OTP 26 by generally enforcing alphanumeric \n  ordering of namespace declarations during encoding\n\n\n[Compare v1.0.0...v1.1.0](https://github.com/rdf-elixir/rdf-xml-ex/compare/v1.0.0...v1.1.0)","ref":"changelog.html#fixed"},{"type":"extras","title":"v1.0.0 - 2022-11-03 - Change Log","doc":"This version is just upgraded to RDF.ex v1.0.\n\nElixir versions < 1.11 are no longer supported\n\n[Compare v0.1.5...v1.0.0](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.5...v1.0.0)","ref":"changelog.html#v1-0-0-2022-11-03"},{"type":"extras","title":"v0.1.5 - 2021-12-23 - Change Log","doc":"This version just fixes the RDF.ex dependency specification to support RDF.ex v0.10.\n\nElixir versions < 1.10 are no longer supported\n\n\n[Compare v0.1.4...v0.1.5](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.4...v0.1.5)","ref":"changelog.html#v0-1-5-2021-12-23"},{"type":"extras","title":"v0.1.4 - 2021-05-21 - Change Log","doc":"","ref":"changelog.html#v0-1-4-2021-05-21"},{"type":"extras","title":"Fixed - Change Log","doc":"- encoding of typed literals failed when a base URI was present\n\n\n[Compare v0.1.3...v0.1.4](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.3...v0.1.4)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.1.3 - 2021-03-12 - Change Log","doc":"","ref":"changelog.html#v0-1-3-2021-03-12"},{"type":"extras","title":"Added - Change Log","doc":"- the `:use_rdf_id` option of the encoder now accepts a function which allows determining\n  for every `RDF.Description` individually if it should be encoded with `rdf:ID`","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Change Log","doc":"- a bug in the decoder introduced by the changes in the last version causing production\n  of erroneous empty strings as objects when property attributes on a nested blank nodes \n  are used\n\n\n[Compare v0.1.2...v0.1.3](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.2...v0.1.3)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.1.2 - 2021-03-09 - Change Log","doc":"","ref":"changelog.html#v0-1-2-2021-03-09"},{"type":"extras","title":"Fixed - Change Log","doc":"- a bug which prevented some valid RDF/XML serializations from successful decoding \n\n\n[Compare v0.1.1...v0.1.2](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.1...v0.1.2)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.1.1 - 2021-02-12 - Change Log","doc":"","ref":"changelog.html#v0-1-1-2021-02-12"},{"type":"extras","title":"Changed - Change Log","doc":"- the `xml:base` specified on the `rdf:RDF` element is stored in the `base_uri`\n  field of the decoded `RDF.Graph`","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Change Log","doc":"- when encoding to a stream in string mode not all elements where strings \n  (some were still iolists) \n\n\n[Compare v0.1.0...v0.1.1](https://github.com/rdf-elixir/rdf-xml-ex/compare/v0.1.0...v0.1.1)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.1.0 - 2020-11-16 - Change Log","doc":"Initial release","ref":"changelog.html#v0-1-0-2020-11-16"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]},"content_type":"text/markdown"}